
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Shipment_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipment_lines = await db.shipment_lines.create(
            {
                id: data.id || undefined,
        
        line_number: data.line_number
        ||
        null
            ,
            
        quantity_shipped: data.quantity_shipped
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await shipment_lines.setShipment( data.shipment || null, {
            transaction,
        });
        
        await shipment_lines.setItem( data.item || null, {
            transaction,
        });
        
        await shipment_lines.setLot( data.lot || null, {
            transaction,
        });
        
        await shipment_lines.setFrom_location( data.from_location || null, {
            transaction,
        });
        

        

        

        return shipment_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const shipment_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                line_number: item.line_number
            ||
            null
            ,
            
                quantity_shipped: item.quantity_shipped
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const shipment_lines = await db.shipment_lines.bulkCreate(shipment_linesData, { transaction });

        // For each item created, replace relation files
        

        return shipment_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const shipment_lines = await db.shipment_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.line_number !== undefined) updatePayload.line_number = data.line_number;
        
        
        if (data.quantity_shipped !== undefined) updatePayload.quantity_shipped = data.quantity_shipped;
        
        
        updatePayload.updatedById = currentUser.id;

        await shipment_lines.update(updatePayload, {transaction});

        
        
        if (data.shipment !== undefined) {
            await shipment_lines.setShipment(
              
              data.shipment,
              
              { transaction }
            );
        }
        
        if (data.item !== undefined) {
            await shipment_lines.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await shipment_lines.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.from_location !== undefined) {
            await shipment_lines.setFrom_location(
              
              data.from_location,
              
              { transaction }
            );
        }
        

        
        

        

        return shipment_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipment_lines = await db.shipment_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of shipment_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of shipment_lines) {
                await record.destroy({transaction});
            }
        });


        return shipment_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const shipment_lines = await db.shipment_lines.findByPk(id, options);

        await shipment_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await shipment_lines.destroy({
            transaction
        });

        return shipment_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const shipment_lines = await db.shipment_lines.findOne(
            { where },
            { transaction },
        );

        if (!shipment_lines) {
            return shipment_lines;
        }

        const output = shipment_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.shipment = await shipment_lines.getShipment({
            transaction
        });
        
        
        output.item = await shipment_lines.getItem({
            transaction
        });
        
        
        output.lot = await shipment_lines.getLot({
            transaction
        });
        
        
        output.from_location = await shipment_lines.getFrom_location({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.shipments,
        as: 'shipment',
        
        where: filter.shipment ? {
          [Op.or]: [
            { id: { [Op.in]: filter.shipment.split('|').map(term => Utils.uuid(term)) } },
            {
              shipment_number: {
                [Op.or]: filter.shipment.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.inventory_lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'from_location',
        
        where: filter.from_location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_location.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.from_location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.line_numberRange) {
                const [start, end] = filter.line_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_number: {
                    ...where.line_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_number: {
                    ...where.line_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_shippedRange) {
                const [start, end] = filter.quantity_shippedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_shipped: {
                    ...where.quantity_shipped,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_shipped: {
                    ...where.quantity_shipped,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.shipment_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'shipment_lines',
                        'quantity_shipped',
                        query,
                    ),
                ],
            };
        }

        const records = await db.shipment_lines.findAll({
            attributes: [ 'id', 'quantity_shipped' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['quantity_shipped', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.quantity_shipped,
        }));
    }

    
};

